#pragma once

#include "StringUtil.h"
#include "PT1OutsideCtrlCmdDef.h"

typedef int (CALLBACK *CMD_CALLBACK_PROC)(void* pParam, CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);

class CPipeServer
{
public:
	CPipeServer(void);
	~CPipeServer(void);

	BOOL StartServer(LPCWSTR lpwszEventName, LPCWSTR lpwszPipeName, CMD_CALLBACK_PROC pfnCmdProc, void* pParam);
	void StopServer();

protected:
	CMD_CALLBACK_PROC m_pCmdProc;
	void* m_pParam;
	wstring m_strEventName;
	wstring m_strPipeName;

	HANDLE m_hStopEvent;
	HANDLE m_hThread;

protected:
	static UINT WINAPI ServerThread(LPVOID pParam);

};
